import javax.media.j3d.* ;
import javax.vecmath.* ;
import com.sun.j3d.utils.geometry.* ;


/**
 * Classe correspondant au sol de l'application
 * Le role de cette classe est de creer le sous graphe de scene
 * representant un sol.
 */
public class Robot
{
    /**
     * Sommet du sous graphe de scene du robot
     */
    protected TransformGroup robot = new TransformGroup() ;

    /**
     * Apparance des elements du robot
     */
    protected Appearance app ;

    /**
     * Constructeur de robot.
     * Son role est de construire le sous graphe de scene associe 
     * au robot
     */
    public Robot()
    {
	Color3f black = new Color3f(0.0f, 0.0f, 0.0f);
	Color3f white = new Color3f(1.0f, 1.0f, 1.0f);

	Color3f objColor = new Color3f(0.0f, 0.0f, 0.8f);
	app = new Appearance() ;
	app.setMaterial(new Material(objColor, objColor, white,
				     black, 80.0f));	

	//--------------------------------------------------------------------//
	// A COMPLETER (construction du graphe)
	//--------------------------------------------------------------------//

    }

    /** 
     * methode renvoyant le sous graphe de scene associe
     * @return le sous graphe de scene
     */
    public Node getRobot()
    {
	return robot ;
    }


    /** 
     * Methode permettant d'appliquer un angle theta a la totalite du bras 
     * gauche
     * @param theta : l'angle d'inclinaison du bras gauche
     */
    public void setBrasGauche(float theta)
    {
    }

    /** 
     * Methode permettant d'appliquer un angle theta a la totalite du bras 
     * droit
     * @param theta : l'angle d'inclinaison du bras droit
     */
    public void setBrasDroit(float theta)
    {
    }

    /** 
     * Methode permettant d'appliquer un angle theta a l'avant bras gauche
     * @param theta : l'angle d'inclinaison du bras gauche
     */
    public void setAvantBrasGauche(float theta)
    {
    }

    /** 
     * Methode permettant d'appliquer un angle theta a l'avant bras droit
     * @param theta : l'angle d'inclinaison du bras droit
     */
    public void setAvantBrasDroit(float theta)
    {
    }

    /**
     * Construction du graphe d'une jambe centree en (0,0,0)
     */
    public Node creerJambe()
    {
	Box leg = new Box(0.5f,0.5f,2.0f,app) ;
	return leg ;
    }

    /** 
     * Construction du graphe du corps centree en (0,0,0)
     */
    public Node creerCorps()
    {
	Box body = new Box(1.5f,0.5f,2.0f,app) ;
	return body ;
    }

    /** 
     * Construction de la tete centree en (0,0,0)
     */ 
    public Node creerTete()
    {
	Box head = new Box(1.0f,0.5f,1.0f,app) ;
	return head ;
    }

    /**
     * Construction de l'avant bras centree en (0,0,0)
     */
    public Node creerAvantBras()
    {
	Box avBras = new Box(0.5f,0.5f,1.5f,app) ;
	return avBras ;
    }

    /**
     * Construction du bras centree en (0,0,0)
     */
    public Node creerBras()
    {
	Box bras = new Box(0.5f,0.5f,1.5f,app) ;
	return bras ;
    }
}
